package org.deephacks.tools4j.config.internal.core;

import java.lang.annotation.Annotation;
import java.util.HashMap;
import java.util.Map;

import javax.enterprise.context.spi.Context;
import javax.enterprise.context.spi.Contextual;
import javax.enterprise.context.spi.CreationalContext;
import javax.enterprise.inject.spi.Bean;

import org.deephacks.tools4j.config.ConfigScope;
import org.deephacks.tools4j.config.RuntimeContext;
import org.deephacks.tools4j.config.model.Lookup;

@SuppressWarnings(value = { "unchecked", "rawtypes" })
public class ConfigCdiContext implements Context {

	RuntimeContext ctx = Lookup.get().lookup(RuntimeContext.class);
	CreationalContext cctx = null;
	Map<Object, Object> cache = new HashMap<Object, Object>();

	@Override
	public Class<? extends Annotation> getScope() {
		return ConfigScope.class;
	}

	@Override
	public <T> T get(Contextual<T> contextual,
			CreationalContext<T> creationalContext) {
		Bean<T> bean = (Bean<T>) contextual;
		cctx = creationalContext;
		return (T) ctx.singleton(bean.getBeanClass());
	}

	@Override
	public <T> T get(Contextual<T> contextual) {
		if (cctx == null) {
			return null;
		}
		Bean<T> bean = (Bean<T>) contextual;
		return (T) ctx.singleton(bean.getBeanClass());
	}

	@Override
	public boolean isActive() {
		return true;
	}
}